;demo06-05.bb - Modeling a nucleus
; ------------------
Graphics3D 640,480 
SetBuffer BackBuffer()

;Key constants
Const ESC_KEY = 1
Const UP_KEY = 200
Const DOWN_KEY = 208
Const LEFT_KEY = 203
Const RIGHT_KEY = 205

; Create camera 
camera=CreateCamera()
PositionEntity camera,0,0,-10

; Create a light 
light=CreateLight()
RotateEntity light,90,0,0

;Create the Sun 
nucleus = CreateSphere(16)
PositionEntity nucleus, 0,0,1

;Give a texture to the sun
tex=LoadTexture( "sunskin.jpg" ) 
EntityTexture nucleus,tex

; Create a pivot for each orbit
pivot1=CreatePivot() 
PositionEntity pivot1,0,0,1 
pivot2=CreatePivot() 
PositionEntity pivot2, 0,0,1 
pivot3=CreatePivot() 
PositionEntity pivot3, 0,0,1

; Create each orbit. 
orbit=CreateSphere(16,pivot1) 
tex1=LoadTexture( "orbit.jpg" )
EntityTexture orbit, tex1 
ScaleEntity orbit, 0.3,0.3,0.3 
PositionEntity orbit,4,0,0

orbit2=CreateSphere(16,pivot2) 
tex2=LoadTexture("orbit.jpg") 
EntityTexture orbit2, tex1 
ScaleEntity orbit2, 0.3,0.3,0.3 
PositionEntity orbit2, 0,0,4

orbit3=CreateSphere(16, pivot3) 
tex2=LoadTexture("orbit.jpg") 
EntityTexture orbit3, tex1 
ScaleEntity orbit3, 0.3,0.3,0.3 
PositionEntity orbit3, 4,0,0


; This following code runs the simulation
While Not KeyDown(ESC_KEY)

	; Turn pivots, making atome orbit around the nucleus. 
	TurnEntity pivot1, 0,3,0 
	TurnEntity pivot2, 3,0,0 
	TurnEntity pivot3, 0,0,3
	; Spinning the nucleus. 
	pitch#=pitch#+3 yaw#=yaw#+3 roll#=roll#+3 
	RotateEntity nucleus,pitch#,yaw#,roll#
	
	;Moving the Camera
	If KeyDown(RIGHT_KEY) TurnEntity camera,0,1,0	
	If KeyDown(LEFT_KEY) TurnEntity camera,0,-1,0
	If KeyDown(UP_KEY) MoveEntity camera,0,0,1
	If KeyDown(DOWN_KEY) MoveEntity camera,0,0,-1

	
	RenderWorld 

	Flip
Wend
End